package main

import (
	"sync"
	"time"

	pbUpstream "github.com/odysseus/odysseus-protocol/gen/proto/go/base/v1"

	"github.com/hashicorp/golang-lru/v2/expirable"
)

type apiQueryTxsForAddr struct {
	uuid  string
	res   chan pbUpstream.TaskResponse
	async bool
}

var ApiQueryTxsByAddrForQueue = make(chan apiQueryTxsForAddr, 1000)

func syncReq(uuid string) chan pbUpstream.TaskResponse {

	res := make(chan pbUpstream.TaskResponse)

	ApiQueryTxsByAddrForQueue <- apiQueryTxsForAddr{
		uuid:  uuid,
		res:   res,
		async: false,
	}

	return res
}

func asyncReq(uuid string) {

	//ApiQueryTxsByAddrForQueue

	ApiQueryTxsByAddrForQueue <- apiQueryTxsForAddr{
		uuid:  uuid,
		async: true,
	}

}

func callbackRes(res pbUpstream.TaskResponse) {

	if v, ok := recordmap.LoadAndDelete(res.TaskId); ok {
		//resAsV, ok := v.(chan pbUpstream.TaskResponse)
		resAsV, ok := v.(apiQueryTxsForAddr)
		if ok {
			if !resAsV.async {
				resAsV.res <- res
			} else {
				asyncmap.Add(res.TaskId, res)
				//asyncmap.Store(res.TaskId, res)
			}
		}
	}
}

func getAsyncRes(uuid string) (pbUpstream.TaskResponse, bool) {

	return asyncmap.Get(uuid)

	// if v, ok := asyncmap.LoadAndDelete(uuid); ok {
	// 	if resAsV, ok := v.(pbUpstream.TaskResponse); ok {
	// 		return resAsV, true
	// 	}
	// }

	// return pbUpstream.TaskResponse{}, false
}

var recordmap sync.Map

var asyncmap *expirable.LRU[string, pbUpstream.TaskResponse]

func init() {

	asyncmap = expirable.NewLRU[string, pbUpstream.TaskResponse](10000000, nil, time.Hour*1)
}

func recordUUID() {
	for message := range ApiQueryTxsByAddrForQueue {

		//apiQueryTxsForAddr
		//recordmap.Store(message.uuid, message.res)
		recordmap.Store(message.uuid, message)
	}
}

// res := make(chan types.Transactions)

// t.ApiQueryTxsByAddrForQueue <- apiQueryTxsForAddr{
// 	addr: (metaTypes.Address)(addr),
// 	res:  res,
// }

// queueTxs := <-res
