package main

import (
	"encoding/json"
	"os"

	"github.com/odysseus/service-registry/common"
)

type demoService struct {
}

func (d demoService) Instance() string {
	hname, _ := os.Hostname()
	return "demo" + hname
}

func (d demoService) Status() string {
	return "running"
}

func (d demoService) ServiceType() common.ServiceType {
	return common.SERVICE_API_GATEWAY
}

type Detail struct {
	QuestAddr        string `json:"quest_addr"`
	KafkaBroker      string `json:"kafka_broker"`
	CallbackAddr     string `json:"callback_addr"`
	CallbackPort     string `json:"callback_port"`
	ListenIpPort     string `json:"listen_ip_port"`
	AigcProduceTopic string `json:"aigc_produce_topic"`
	TaskreceiptTopic string `json:"task_receipt_topic"`
	TaskProof        string `json:"task_proof"`
	Logserver        string `json:"log_server"`
	RedisAddr        string `json:"redis_addr"`
	RedisPassWd      string `json:"redis_passwd"`
	MysqlAddr        string `json:"mysql_addr"`
	MysqlPort        int    `json:"mysql_port"`
	MysqlDbName      string `json:"mysql_db_name"`
	MysqlUser        string `json:"mysql_user"`
	MysqlPassWd      string `json:"mysql_passwd"`
	LogLevel         int    `json:"log_level"`

	/////////////////////////////////////////
	IP          string `json:"ip"`
	WorkerCount int    `json:"worker_count"`
}

var detailVar = Detail{}

func (d demoService) DetailInfo() (json.RawMessage, error) {
	// detail := struct {
	// 	IP          string `json:"ip"`
	// 	WorkerCount int    `json:"worker_count"`
	// }{}
	// detail.IP = ""
	// detail.WorkerCount = 10
	return json.Marshal(detailVar)
}

// func TestRegistry(t *testing.T) {
// 	r := NewRegistry(RedisConnParam{
// 		Addr:     "localhost:6379",
// 		Password: "",
// 		DbIndex:  0,
// 	}, demoService{})
// 	r.Start()
// 	time.Sleep(time.Second * 5)
// 	r.Stop()
// }

// package main

// import (
// 	"encoding/json"
// 	"time"

// 	"github.com/odysseus/service-registry/common"
// 	registry "github.com/odysseus/service-registry/registry"
// )

// type demoService struct {
// }

// func (d demoService) ServiceType() common.ServiceType {
// 	return common.SERVICE_API_GATEWAY
// }

// func (d demoService) Endpoint() string {
// 	return "http://service-endpoint_ai-api-magr:6001"
// }

// func (d demoService) DetailInfo() (json.RawMessage, error) {

// 	//return nil, nil
// 	detail := struct {
// 		IP          string `json:"ip"`
// 		WorkerCount int    `json:"worker_count"`
// 	}{}
// 	detail.IP = ""
// 	detail.WorkerCount = 10
// 	return json.Marshal(detail)
// }

// func Registry(redisAddr, passWd string) {

// 	// _ = query.GatewayInfo{
// 	// 	Endpoint: "http://query-endpoint_ai-api-magr:6001",
// 	// }

// 	r := registry.NewRegistry(registry.RedisConnParam{
// 		Addr:     redisAddr,
// 		Password: passWd,
// 		DbIndex:  0,
// 	}, demoService{})
// 	r.Start()
// 	time.Sleep(time.Second * 5)
// 	r.Stop()
// }
